// 13/03/2023 17:40:15
// ACTUATOR_COBAK6e.ino
// ArduinoBLE - Version: Latest
#include <ArduinoBLE.h>
#include <Servo.h>
Servo myservo1, myservo2, myservo3, myservo4, myservo5;;
#define SERVICE_UUID "0000FFE0-0000-1000-8000-00805F9B34FB"
#define CHARACTERISTIC_UUID "0000FFE1-0000-1000-8000-00805F9B34FB"

/*
  LED

  This example creates a BLE peripheral with service that contains a
  characteristic to control an LED.

  The circuit:
  - Arduino MKR WiFi 1010, Arduino Uno WiFi Rev2 board, Arduino Nano 33 IoT,
    Arduino Nano 33 BLE, or Arduino Nano 33 BLE Sense board.

  You can use a generic BLE central app, like LightBlue (iOS and Android) or
  nRF Connect (Android), to interact with the services and characteristics
  created in this sketch.

  This example code is in the public domain.

  *** An LED (plus resistor) can be wired to a microcontroller in two ways ***
  (1) Between pin and GND in which case you have to drive the pin HIGH to switch the LED on.
  (2) Between pin and Vcc in which case you have to drive the pin LOW to switch the LED on.
*/

//vars
unsigned long lgUpdateTime;
char sSensorVals[16];
unsigned int nilai_sensor;
unsigned int nilai_sensor2;

// BLE LED Service
BLEService ledService(SERVICE_UUID);

// BLE LED Switch Characteristic
BLEStringCharacteristic switchCharacteristic(CHARACTERISTIC_UUID, BLEWrite | BLENotify, 32);

void setup()
{
               //Serial.begin(9600);
               Serial.begin(115200);
               lgUpdateTime = millis();
//               while (!Serial);

               // set LED pin to output mode
               pinMode(LED_BUILTIN, OUTPUT);
               myservo1.attach(2);
               myservo2.attach(3);
               myservo3.attach(4);
               myservo4.attach(5);
               myservo5.attach(6);

               digitalWrite(LED_BUILTIN, LOW);  // turn LED_BUILTIN on (when the central disconnects, turn off the LED)
               

               // begin initialization
               if (!BLE.begin()) {
                 Serial.println("starting BLE device failed!");

                 while (1);
               }

               // set advertised local name and service UUID:
               BLE.setLocalName("Nano_33_BLE");
               BLE.setAdvertisedService(ledService);

               // add the characteristic to the service
               ledService.addCharacteristic(switchCharacteristic);

               // add service
               BLE.addService(ledService);

               // set the initial value for the characeristic:
               // switchCharacteristic.writeValue('0');

               // start advertising
               BLE.advertise();

               //Serial.println("BLE device Nano_33 active, waiting for connection");
}

void loop()
{
  // listen for BLE peripherals to connect:
  BLEDevice central = BLE.central();

               // if a central is connected to peripheral:
               if (central)
               {
                         //Serial.print("Connected to central: ");
                         digitalWrite(LED_BUILTIN, HIGH);
                         // print the central's MAC address:
                         //Serial.println(central.address());

                         // while the central is still connected to peripheral:
                         while (central.connected())
                         {

                                   if(millis() - lgUpdateTime > 1000)           //Loop approx every 1 second
                                   {
                                             lgUpdateTime = millis();
                                             nilai_sensor = analogRead(A0);     
                                            nilai_sensor2 = analogRead(A1);

                                                     sSensorVals[0] = '\0';
                                             sprintf(sSensorVals, "%u,%u", nilai_sensor, nilai_sensor2);
                                             switchCharacteristic.writeValue(sSensorVals); //Send value pair to App
                                             Serial.println(sSensorVals);
                                   }

                                   // Looks Like you want to receive a command from the App here?
                                   //if (switchCharacteristic.written())
                                   //{
                                   //          switch (switchCharacteristic.value())
                                   //          {
                                   //            case 1:
                                   //              Serial.println("HAND CLOSE");
                                   //              myservo1.write(150);
                                   //              myservo2.write(150);
                                   //              myservo3.write(150);
                                   //              myservo4.write(150);
                                   //              myservo5.write(150);
                                   //              break;
                                   //            case 2:
                                   //              Serial.println("CURVE");
                                   //              myservo1.write(90);
                                   //              myservo2.write(90);
                                   //              myservo3.write(90);
                                   //              myservo4.write(90);
                                   //              myservo5.write(90);
                                   //              break;
                                   //            case 3:
                                   //              Serial.println("PINCH");
                                   //              myservo1.write(90);
                                   //              myservo2.write(90);
                                   //              myservo3.write(90);
                                   //              myservo4.write(39);
                                   //              myservo5.write(39);
                                   //              break;
                                   //           case 4:
                                   //              Serial.println("OPEN 1");
                                   //              myservo1.write(39);
                                   //              myservo2.write(39);
                                   //              myservo3.write(39);
                                   //              myservo4.write(39);
                                   //              myservo5.write(39);
                                   //              break;
                                   //            case 5:
                                   //              Serial.println("OPEN 2");
                                   //              myservo1.write(39);
                                   //              myservo2.write(39);
                                   //              myservo3.write(39);
                                   //              myservo4.write(39);
                                   //              myservo5.write(39);
                                   //              break;
                                   //            case 6:
                                   //              Serial.println("OPEN 3");
                                   //              myservo1.write(39);
                                   //              myservo2.write(39);
                                   //              myservo3.write(39);
                                   //              myservo4.write(39);
                                   //              myservo5.write(39);
                                   //              break;
                                   //
                                   //          }
                                   //}
                         }

                         // when the central disconnects, print it out:
                         Serial.print("Disconnected from central: ");
                         Serial.println(central.address());
                         digitalWrite(LED_BUILTIN, LOW);  // when the central disconnects, turn off the LED
                       
               }
}
